import UIKit
import Flutter

@UIApplicationMain
@objc class AppDelegate: FlutterAppDelegate {
  override func application(
    _ application: UIApplication,
    didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?
  ) -> Bool {
    GeneratedPluginRegistrant.register(with: self)
    
    let controller : FlutterViewController = window?.rootViewController as! FlutterViewController;
    let methodChannel = FlutterMethodChannel.init(name: "com.sicilyliu", binaryMessenger: controller.binaryMessenger);
    
    methodChannel.setMethodCallHandler({
        (call : FlutterMethodCall, result: FlutterResult) -> Void in
        print(call.method)
        if (call.method == "native hello") {
            let dic = NSMutableDictionary.init(dictionary:["code":300, "message":"native say hello to flutter"]);
            methodChannel.invokeMethod("hello", arguments: dic);
        }
        else if (call.method == "battery") {
            receiveBatteryLevel(result: result);
        }
        else if (call.method == "hello") {
            let dic = NSMutableDictionary.init(dictionary:["code":200, "message":"native receive hello from flutter"]);
            result(dic);
        }
        else {
            result(FlutterMethodNotImplemented);
        }
    });
    
    return super.application(application, didFinishLaunchingWithOptions: launchOptions)
  }
}

private func receiveBatteryLevel(result: FlutterResult) {
    let device = UIDevice.current;
    device.isBatteryMonitoringEnabled = true;
    if (device.batteryState == UIDevice.BatteryState.unknown) {
        result(FlutterError.init(code: "UnAvailable", message: "电池信息不可用", details: nil));
    }
    else {
        result(Int(device.batteryLevel * 100));
    }
}
